{% extends 'tests/base.html' %}

{% load humanize %}

{% block title %} | {{ test.name }} | {{ session.name }} {% endblock %}

{% block content %}
    <a href="{% url 'test_sessions' test_id=test.id %}" class="btn btn-link float-left text-dark">
        <i class="fa fa-arrow-left mr-2"></i>{{ test.name }}
    </a>
    <div class="container">
        <h1 class="m-3 text-center">{{ session.name }}</h1>
        <div class="row bg-light m-3 p-3 rounded border">
            <div class="col-6 border-right">
                <div class="d-flex flex-row align-items-center justify-content-between">
                    <p class="m-0">
                        {% if session.registrations_enabled %}
                            Registrations are enabled
                        {% else %}
                            Registrations are disabled
                        {% endif %}
                    </p>
                    <form onsubmit="submit_form(event)">
                        {% csrf_token %}
                        <input type="hidden" name="action" value="toggle_registrations_enabled"/>
                        <button class="btn btn-info m-2">
                            {% if session.registrations_enabled %}
                                Disable
                            {% else %}
                                Enable
                            {% endif %}
                        </button>
                    </form>
                </div>
                <div class="d-flex flex-row align-items-center justify-content-between">
                    <p class="m-0">
                        {% if session.opening_enabled %}
                            Opening is enabled
                        {% else %}
                            Opening is disabled
                        {% endif %}
                    </p>
                    <form onsubmit="submit_form(event)">
                        {% csrf_token %}
                        <input type="hidden" name="action" value="toggle_opening_enabled"/>
                        <button class="btn btn-info m-2">
                            {% if session.opening_enabled %}
                                Disable
                            {% else %}
                                Enable
                            {% endif %}
                        </button>
                    </form>
                </div>
                <div class="d-flex flex-row align-items-center justify-content-between">
                    <p class="m-0">

                        {{ proctors | length | apnumber | capfirst }}
                        {% if proctors|length > 1 %}
                            proctors
                        {% else %}
                            proctor
                        {% endif %}
                    </p>
                    <button type="button" data-toggle="modal" data-target="#proctorModal" class="btn btn-info m-2">
                        Manage
                    </button>
                </div>
            </div>

            <!-- Proctor Management Modal -->
            <div class="modal fade" id="proctorModal" tabindex="-1" role="dialog" aria-labelledby="proctorModalLabel"
                 aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Manage proctors</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <div class="list-group list-group-flush">
                                <div class="list-group-item d-flex justify-content-between">
                                    {{ session.test.creator.first_name }} {{ session.test.creator.last_name }}
                                    <span class="btn disabled">Test Creator</span>
                                </div>
                                {% for proctor in proctors %}
                                    {% if session.test.creator != proctor %}
                                        <div class="list-group-item d-flex justify-content-between">
                                            {{ proctor.first_name }} {{ proctor.last_name }}
                                            <form onsubmit="submit_form(event)">
                                                {% csrf_token %}
                                                <input type="hidden" name="action" value="manual_remove_proctor"/>
                                                <input type="hidden" name="manualRemProct"
                                                       value="{{ proctor.username }}"/>
                                                    <button class="btn btn-danger btn-sm" data-toggle="tooltip"
                                                            data-placement="right" title="DELYEET proctor">
                                                        <i class="fa fa-user-times"></i>
                                                    </button>
                                            </form>
                                        </div>
                                    {% endif %}
                                {% endfor %}
                                <div class="list-group-item">
                                    <form onsubmit="submit_form(event)">
                                        {% csrf_token %}
                                        <input type="hidden" name="action" value="manual_add_proctor"/>
                                        <div class="form-group row">
                                            <div class="col-9">
                                                <input type="text" class="form-control" name="manualAddProct" id="manualAddProct"
                                                       placeholder="Proctor Username">
                                            </div>
                                            <div class="col-3">
                                                <button type="submit" class="btn btn-info w-100">Add</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-6">
                <form onsubmit="submit_form(event)" class="m-2 border-bottom">
                    {% csrf_token %}
                    <input type="hidden" name="action" value="manual_register_user"/>
                    <label for="manualRegUser">Register a user for this session:</label>
                    <div class="form-group row">
                        <div class="col-9">
                            <input type="text" class="form-control" name="manualRegUser" id="manualRegUser"
                                   placeholder="Username">
                        </div>
                        <div class="col-3">
                            <button type="submit" class="btn btn-info w-100">Register</button>
                        </div>
                    </div>
                </form>
                {% if swipe_enabled %}
                    <div class="d-flex flex-row align-items-center justify-content-between m-2 pt-1">
                        <a class="btn btn-info" href="{% url 'card_swipe_in' session_id=session.id %}">Card Swipe In</a>
                        <a class="btn btn-info" href="{% url 'card_swipe_out' session_id=session.id %}">Card Swipe
                            Out</a>
                    </div>
                {% endif %}
            </div>
        </div>
    </div>
    <div class="d-flex flex-wrap justify-content-center">
        {% for registration, status, lastattempt, attempts in registrations %}
            <div class="m-3" style="width: 18em; height: 10em">
                <div class="card" id="card{{ registration.id }}">
                    <div class="card-header d-flex justify-content-between">
                        <h5 class="">{{ registration.taker.get_full_name }} </h5>
                        {% if status == "REGISTERED_FOR_THIS_SESSION_NOT_SWIPED_IN" or status == "REGISTERED_FOR_THIS_SESSION_NOT_OPEN_OPENING_DISABLED" %}
                            <form onsubmit="submit_form(event)">
                                {% csrf_token %}
                                <input type="hidden" name="action" value="manual_unregister_user"/>
                                <input type="hidden" name="manualUnRegUser" value="{{ registration.taker.username }}"/>
                                <button class="btn btn-danger btn-sm" data-toggle="tooltip" data-placement="bottom"
                                        title="DELYEET from session">
                                    <i class="fa fa-user-times"></i>
                                </button>
                            </form>
                        {% endif %}
                    </div>
                    <div class="list-group list-group-flush">
                        {% if lastattempt %}
                            {% with attempt=lastattempt.0 grade=lastattempt.1 %}
                                {% if grade != None %}
                                    {% if attempt.passed %}
                                        <div class="list-group-item d-flex flex-row align-items-center justify-content-between list-group-item-success"
                                             style="height: 3em">
                                            <span>Pass at {{ attempt.submitted | date:"n/j/y G:iA" }}</span>
                                            <span style="width: 4em" class="text-right">{{ grade | stringformat:".0f" }}%</span>
                                        </div>
                                    {% else %}
                                        <div class="list-group-item d-flex flex-row align-items-center justify-content-between list-group-item-danger"
                                             style="height: 3em">
                                            <span>Fail at {{ attempt.submitted | date:"n/j/y G:iA" }}</span>
                                            <span style="width: 4em" class="text-right">{{ grade | stringformat:".0f" }}%</span>
                                        </div>
                                    {% endif %}
                                {% elif attempt.opened != None %}
                                    <div class="list-group-item d-flex flex-row align-items-center justify-content-between list-group-item-info"
                                         style="height: 3em">
                                        <span>Open at {{ attempt.opened | date:"n/j/y G:iA" }}</span>
                                    </div>
                                {% endif %}
                            {% endwith %}
                        {% else %}
                            <div class="list-group-item d-flex flex-row align-items-center justify-content-between"
                                 style="height: 3em">
                                <span>No attempts</span>
                            </div>
                        {% endif %}
                    </div>
                    <div class="list-group list-group-flush collapse border-top-0" id="list{{ registration.id }}">
                        {% for attempt, grade in attempts %}
                            {% if grade != None %}
                                {% if attempt.passed %}
                                    <div class="list-group-item d-flex flex-row align-items-center justify-content-between list-group-item-success"
                                         style="height: 3em">
                                        <span>Pass at {{ attempt.submitted | date:"n/j/y G:iA" }}</span>
                                        <span style="width: 4em"
                                              class="text-right">{{ grade | stringformat:".0f" }}%</span>
                                    </div>
                                {% else %}
                                    <div class="list-group-item d-flex flex-row align-items-center justify-content-between list-group-item-danger"
                                         style="height: 3em">
                                        <span>Fail at {{ attempt.submitted | date:"n/j/y G:iA" }}</span>
                                        <span style="width: 4em"
                                              class="text-right">{{ grade | stringformat:".0f" }}%</span>
                                    </div>
                                {% endif %}
                            {% elif attempt.opened != None %}
                                <div class="list-group-item d-flex flex-row align-items-center justify-content-between list-group-item-info"
                                     style="height: 3em">
                                    <span>Open at {{ attempt.opened | date:"n/j/y G:iA" }}</span>
                                </div>
                            {% endif %}
                        {% endfor %}
                    </div>
                    {% with attempts_len=attempts|length %}
                        <a class="card-footer text-muted font-weight-light border-top-0 d-flex flex-row justify-content-between"
                           style="text-decoration: none"
                                {% if attempts_len %}
                           data-toggle="collapse" href="#list{{ registration.id }}" role="button"
                                {% endif %}
                        >
                            {% if registration.swiped_out != None %}
                                Swipe out at {{ registration.swiped_out | date:"n/j/y G:iA" }}
                            {% elif registration.swiped_in != None %}
                                Swipe in at {{ registration.swiped_in | date:"n/j/y G:iA" }}
                            {% else %}
                                Register at {{ registration.registered | date:"n/j/y G:iA" }}
                            {% endif %}
                            {% if attempts_len %}
                                <div>
                                    <i class="fa fa-chevron-down" id="btn{{ registration.id }}"></i>
                                </div>
                            {% endif %}
                        </a>
                    {% endwith %}
                    <script>
                        $('#list{{ registration.id }}').on('show.bs.collapse', function () {
                            $('#card{{ registration.id }}').addClass('shadow-lg');
                            $('#card{{ registration.id }}').css('z-index', 9);
                            $('#btn{{ registration.id }}').removeClass('fa-chevron-down');
                            $('#btn{{ registration.id }}').addClass('fa-chevron-up');
                        });
                        $('#list{{ registration.id }}').on('hidden.bs.collapse', function () {
                            $('#card{{ registration.id }}').removeClass('shadow-lg');
                            $('#card{{ registration.id }}').css('z-index', 0);
                        });
                        $('#list{{ registration.id }}').on('hide.bs.collapse', function () {
                            $('#btn{{ registration.id }}').removeClass('fa-chevron-up');
                            $('#btn{{ registration.id }}').addClass('fa-chevron-down');
                        });
                    </script>
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}
